<< problem 278 - Linear Combinations of Semiprimes | Panaitopol Primes - problem 291 >> |

# Problem 286: Scoring probabilities

(see projecteuler.net/problem=286)

Barbara is a mathematician and a basketball player.

She has found that the probability of scoring a point when shooting from a distance x is exactly (1 - x/q),

where q is a real constant greater than 50.

During each practice run, she takes shots from distances x = 1, x = 2, ..., x = 50 and, according to her records,

she has precisely a 2 % chance to score a total of exactly 20 points.

Find q and give your answer rounded to 10 decimal places.

# My Algorithm

My solution is based on Dynamic Programming and bisection search.

The function `probability`

returns the chance that exactly 20 are made from distances 1,2,...,50 given a certain q.

And the `main`

function iteratively narrows a range of potential values for q until the range is so small that I can be sure

to be extremely close to the true value of q (error is less than 10^-10).

The bisection part was obvious to me right from the start.

However, I needed a few minutes to figure out that I can use a Dynamic Programming approach (again :-) ) for `probability`

.

I was worried that the cache size might grow too fast and tried to solve the problem analytically.

But as it turns out the cache contains only about 33000 values at the end (even without clearing it when a new q is processed).

## Alternative Approaches

My simple recursion could be probably replaced by an iterative algorithm because of the low number of different states (`made, distance`

).

## Note

I play basketball and in my opinion the problem is phrased incorrectly:

according to the "Project Euler Basketball rules" Barbara gets only 1 point per shot she made.

In real life, a shot is usually worth 2 points. You get 1 point for a free throw and 3 points for a "long-range" shot.

The correct result is found after 39 iterations.

Due to the nature of bisection, narrowing the initial interval doesn't really speed up the process.

# My code

… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too.

#include <iostream>
#include <iomanip>
#include <map>
// Barbara hits exactly 20 times out of 50 attempted shots

unsigned int threshold = 20;
const unsigned int maxDistance = 50;
// Barbara has a 2% chance of making exactly 20 points (50 attempts)

const double chanceHitExactly = 0.02;
// find probability of making 20 shots given a certain q
// note: second and third parameter are needed for internal recursion only

double probability(double q, unsigned int made = 0, unsigned int distance = 1)
{
// made too many shots
if (made > threshold)
return 0;
// finished ? => made exactly 20 shots ?
if (distance > maxDistance)
return made == threshold ? 1 : 0;
// memoize
static std::map<std::pair<unsigned int, double>, double> cache;
auto id = std::make_pair(made * (maxDistance + 1) + distance, q);
auto lookup = cache.find(id);
if (lookup != cache.end())
return lookup->second;
// compute probabilities
double chanceHit = 1 - distance / q;
double chanceMiss = 1 - chanceHit; // can be simplified to distance/q
// go back one step
distance++;
// and attempt one more shot: could be a hit, could be a miss ...
double result = chanceHit * probability(q, made + 1, distance) +
chanceMiss * probability(q, made, distance);
cache[id] = result;
return result;
}
int main()
{
// user-defined number of made shots from distances 1..50
std::cin >> threshold;
// start with a large interval of potential values of q:
// q > 50 because otherwise there would be a negative probability for the shot from distance 50
double low = maxDistance;
// q <= 100 is a pretty random choice ... and it's much larger than the true value q
double high = 100;
// ten decimal places
double accuracy = 0.0000000001;
// while interval is still too wide ...
while (high - low > accuracy)
{
// analyze its midpoint
auto mid = (high + low) / 2;
// below 2% ?
if (probability(mid) < chanceHitExactly)
high = mid; // mid is larger than the true q
else
low = mid; // mid is smaller than the true q
}
if (low > 50)
// low == high (at least with respect to their first 10 decimal places)
std::cout << std::fixed << std::setprecision(10) << low << std::endl;
else
std::cout << "impossible" << std::endl;
return 0;
}

This solution contains 13 empty lines, 19 comments and 3 preprocessor commands.

# Interactive test

You can submit your own input to my program and it will be instantly processed at my server:

This is equivalent to`echo 25 | ./286`

Output:

*Note:* the original problem's input `20`

__cannot__ be entered

because just copying results is a soft skill reserved for idiots.

*(this interactive test is still under development, computations will be aborted after one second)*

# Benchmark

The correct solution to the original Project Euler problem was found in 0.01 seconds on a Intel® Core™ i7-2600K CPU @ 3.40GHz.

Peak memory usage was about 4 MByte.

(compiled for x86_64 / Linux, GCC flags: `-O3 -march=native -fno-exceptions -fno-rtti -std=c++11 -DORIGINAL`

)

See here for a comparison of all solutions.

**Note:** interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without `-DORIGINAL`

.

# Changelog

July 6, 2017 submitted solution

July 6, 2017 added comments

# Difficulty

Project Euler ranks this problem at **50%** (out of 100%).

# Links

projecteuler.net/thread=286 - **the** best forum on the subject (*note:* you have to submit the correct solution first)

# Heatmap

green problems solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too.

yellow problems score less than 100% at Hackerrank (but still solve the original problem).

gray problems are already solved but I haven't published my solution yet.

blue problems are solved and there wasn't a Hackerrank version of it at the time I solved it or I didn't care about it because it differed too much.

red problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte.

*Please click on a problem's number to open my solution to that problem:*

1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |

26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |

51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |

76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |

101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |

126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |

151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |

176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |

201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |

226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |

251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |

276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |

301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |

326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |

351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |

376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |

401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |

426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |

451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |

476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |

501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |

526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |

I scored 13,183 points (out of 15300 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.

Look at my progress and performance pages to get more details.

My username at Project Euler is

**stephanbrumme**while it's stbrumme at Hackerrank.

# Copyright

I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.

All of my solutions can be used for any purpose and I am in no way liable for any damages caused.

You can even remove my name and claim it's yours. But then you shall burn in hell.

The problems and most of the problems' images were created by Project Euler.

Thanks for all their endless effort.

<< problem 278 - Linear Combinations of Semiprimes | Panaitopol Primes - problem 291 >> |